package com.fdkanfang.web.shiro;

import com.alibaba.fastjson.JSONObject;
import com.fdkanfang.common.exception.JwtAuthenticationException;
import lombok.extern.log4j.Log4j2;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authc.AuthenticationException;
import org.apache.shiro.web.filter.authc.BasicHttpAuthenticationFilter;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.RequestMethod;

import javax.servlet.ServletOutputStream;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;


/**
 * 自定义拦截规则
 */
@Log4j2
public class JWTFilter extends BasicHttpAuthenticationFilter {


    /**
     * 执行登录验证
     */
    @Override
    protected boolean executeLogin(ServletRequest request, ServletResponse response) {
        HttpServletRequest httpServletRequest = (HttpServletRequest) request;
        String authorization = httpServletRequest.getHeader("Authorization");

        if (authorization == null) {
            throw new JwtAuthenticationException(5005, "Authorization is null");
        }


        JWTToken token = new JWTToken(authorization);

        // 提交给realm进行登入，如果错误他会抛出异常并被捕获
        getSubject(request, response).login(token);



        // 如果没有抛出异常则代表登入成功，返回true
        return true;
    }

    /**
     * 这里我们详细说明下为什么最终返回的都是true，即允许访问
     * 例如我们提供一个地址 GET /article
     * 登入用户和游客看到的内容是不同的
     * 如果在这里返回了false，请求会被直接拦截，用户看不到任何东西
     * 所以我们在这里返回true，Controller中可以通过 subject.isAuthenticated() 来判断用户是否登入
     * 如果有些资源只有登入用户才能访问，我们只需要在方法上面加上 @RequiresAuthentication 注解即可
     * 但是这样做有一个缺点，就是不能够对GET,POST等请求进行分别过滤鉴权(因为我们重写了官方的方法)，但实际上对应用影响不大
     *
     * owen:
     *  return false ,表示全局拦截，必须登录才可以访问接口，除非配置了免拦截
     *  "" @RequiresAuthentication 现在不需要配置这个注解来免登录
     *
     */
    @Override
    protected boolean isAccessAllowed(ServletRequest request, ServletResponse response, Object mappedValue) {
            try {
                executeLogin(request, response);
                return true;
            } catch (Exception e) {
                /** 这个异常需要自己写，全局捕获不了*/

                // 认证出现异常，传递错误信息msg
                String msg = e.getMessage();
                // 获取应用异常(该Cause是导致抛出此throwable(异常)的throwable(异常))
                Throwable throwable = e.getCause();
                JSONObject jsonObject = new JSONObject();
                if (throwable instanceof JwtAuthenticationException) {
                    jsonObject.put("status", ((JwtAuthenticationException) throwable).getCode());
                    jsonObject.put("message", ((JwtAuthenticationException) throwable).getMsg());
                }else{
                    log.error(msg);
                    jsonObject.put("status", 5002);
                    jsonObject.put("message", "token invalid");
                }
                // 直接返回Response信息
                this.writeResponse(response, jsonObject);

                return false;
            }
    }




    /**
     * 对跨域提供支持
     * 只对需要token验证的有效，不需要验证的还是需要用注解处理一下
     *
     */
    @Override
    protected boolean preHandle(ServletRequest request, ServletResponse response) throws Exception {
        HttpServletRequest httpServletRequest = (HttpServletRequest) request;
        HttpServletResponse httpServletResponse = (HttpServletResponse) response;
        httpServletResponse.setHeader("Access-control-Allow-Origin", httpServletRequest.getHeader("Origin"));
        httpServletResponse.setHeader("Access-Control-Allow-Methods", "GET,POST,OPTIONS,PUT,DELETE");
        httpServletResponse.setHeader("Access-Control-Allow-Headers", httpServletRequest.getHeader("Access-Control-Request-Headers"));
        // 跨域时会首先发送一个option请求，这里我们给option请求直接返回正常状态
        if (httpServletRequest.getMethod().equals(RequestMethod.OPTIONS.name())) {
            httpServletResponse.setStatus(HttpStatus.OK.value());
            return false;
        }
        return super.preHandle(request, response);
    }


    /**
     * 无需转发，直接返回Response信息
     *
     */
    private void writeResponse(ServletResponse response, JSONObject msg) {
        response.setCharacterEncoding("UTF-8");
        response.setContentType("application/json; charset=utf-8");
        ServletOutputStream outputStream = null;
        try {
            outputStream = response.getOutputStream();
        } catch (IOException e) {
            e.printStackTrace();
        }
        assert outputStream != null;
        PrintWriter printWriter = new PrintWriter(outputStream, true);
        printWriter.write(msg.toString());//直接将json输出到页面
        printWriter.flush();
        printWriter.close();

    }
}
